Package: pkgconfig
Title: Private Configuration for 'R' Packages
Version: 2.0.3
Author: Gábor Csárdi
Maintainer: Gábor Csárdi <csardi.gabor@gmail.com>
Description: Set configuration options on a per-package basis.
    Options set by a given package only apply to that package,
    other packages are unaffected.
License: MIT + file LICENSE
LazyData: true
Imports: utils
Suggests: covr, testthat, disposables (>= 1.0.3)
URL: https://github.com/r-lib/pkgconfig#readme
BugReports: https://github.com/r-lib/pkgconfig/issues
Encoding: UTF-8
NeedsCompilation: no
Packaged: 2019-09-22 08:42:40 UTC; gaborcsardi
Repository: CRAN
Date/Publication: 2019-09-22 09:20:02 UTC
Built: R 4.4.0; ; 2026-02-17 15:58:00 UTC; unix

Package: pkgconfig
Title: Private Configuration for 'R' Packages
Version: 2.0.3
Author: Gábor Csárdi
Maintainer: Gábor Csárdi <csardi.gabor@gmail.com>
Description: Set configuration options on a per-package basis.
    Options set by a given package only apply to that package,
    other packages are unaffected.
License: MIT + file LICENSE
LazyData: true
Imports: utils
Suggests: covr, testthat, disposables (>= 1.0.3)
URL: https://github.com/r-lib/pkgconfig#readme
BugReports: https://github.com/r-lib/pkgconfig/issues
Encoding: UTF-8
NeedsCompilation: no
Packaged: 2019-09-22 08:42:40 UTC; gaborcsardi
Repository: CRAN
Date/Publication: 2019-09-22 09:20:02 UTC

# Private configuration for R packages

[![Linux Build Status](https://travis-ci.org/r-lib/pkgconfig.svg?branch=master)](https://travis-ci.org/r-lib/pkgconfig)
[![Windows Build status](https://ci.appveyor.com/api/projects/status/github/r-lib/pkgconfig?svg=true)](https://ci.appveyor.com/project/gaborcsardi/pkgconfig)
[![](http://www.r-pkg.org/badges/version/pkgconfig)](http://www.r-pkg.org/pkg/pkgconfig)
[![](http://cranlogs.r-pkg.org/badges/pkgconfig)](http://www.r-pkg.org/pkg/pkgconfig)
[![Coverage Status](https://img.shields.io/codecov/c/github/r-lib/pkgconfig/master.svg)](https://codecov.io/github/r-lib/pkgconfig?branch=master)

Easy way to create configuration parameters in your R package. Configuration
values set in different packages are independent.

Call `set_config()` to set a configuration parameter.
Call `get_config()` to query it.

## Installation

```r
install.packages("pkgconfig")
```

## Typical usage

> Note: this is a real example, but it is not yet implemented in
> the CRAN version of the `igraph` package.

The igraph package has two ways of returning a set of vertices. Before
version 1.0.0, it simply returned a numeric vector. From version 1.0.0
it sets an S3 class on this vector by default, but it has an option
called `return.vs.es` that can be set to `FALSE` to request the old
behavior.

The problem with the `return.vs.es` option is that it is global. Once set
to `FALSE` (interactively or from a package), R will use that setting in
all packages, which breaks packages that expect the new behavior.

`pkgconfig` solves this problem, by providing configuration settings
that are private to packages. Setting a configuration key from a
given package will only apply to that package.

## Workflow

Let's assume that two packages, `pkgA` and `pkgB`, both set the igraph
option `return.vs.es`, but `pkgA` sets it to `TRUE`, and `pkgB` sets it
to `FALSE`. Here is how their code will look.

### `pkgA`

`pkgA` imports `set_config` from the `pkgconfig` package, and sets
the `return.vs.es` option from it's `.onLoad` function:

```r
.onLoad <- function(lib, pkg) {
    pkgconfig::set_config("igraph::return.vs.es" = TRUE)
}
```

### `pkgB`

`pkgB` is similar, but it sets the option to `FALSE`:

```r
.onLoad <- function(lib, pkg) {
    pkgconfig::set_config("igraph::return.vs.es" = FALSE)
}
```

### `igraph`

The igraph package will use `get_config` to query the option, and
will supply a fallback value for the cases when it is not set:

```r
return_vs_es_default <- TRUE
# ...
igraph_func <- function() {
    # ...
    pkgconfig::get_config("igraph::return.vs.es", return_vs_es_default)
	# ...
}
```

If `igraph_func` is called from `pkgA` (maybe through other packages),
`get_config` will return `TRUE`, and if it is called from `pkgB`,
`get_config` will return `FALSE`. If no package on the call stack
sets the `igraph::return.vs.es` option, then its default value is used,
as specified in `igraph`.

## What if `pkgA` calls `pkgB`?

It might happen that both `pkgA` and `pkgB` set an option, and
`pkgA` also calls functions from `pkgB`, which in turn, might call
`igraph`. In this case the package that is further down the call
stack wins. In other words, if the call sequence looks like this:

```
... -> pkgA -> ... -> pkgB -> ... -> igraph
```

then `pkgB`'s value is used in `igraph`. (Assuming the last  `...` does
not contain a call to `pkgA` of course.)

## Feedback

Please comment in the
[Github issue tracker](https://github.com/r-lib/pkgconfig/issues)
of the project.

## License

MIT © [Gábor Csárdi](https://github.com/gaborcsardi)

PkgConfig

This module provides a pure perl version of pkg-config, a program
that provides compiler and linker flags for installed packages.
See:

http://www.freedesktop.org/wiki/Software/pkg-config/

for the original.  The POD for the module contains a more detailed
description of how it works and the differences from the original.
You can view it before installing using perldoc:

 % perldoc lib/PkgConfig.pm

INSTALLATION

To install this module, run the following commands:

	perl Makefile.PL
	make
	make test
	make install

You may change the scripts that get installed by using the --script
option one or more times.  For example, if you prefer not to install
pkg-config.pl you could do this:

 % perl Makefile.PL --script=ppkg-config

Or if you want to use ppkg-config and pkg-config (say you are on a
platform that  does not provide it):

 % perl Makefile.PL --script=pkg-config --script=ppkg-config

Or if you don't want any scripts installed at all:

 % perl Makefile.PL --script=none

The default is "--script=ppkg-config --script=pkg-config.pl" except for
Windows, where the default is just "--script=ppkg-config".

SUPPORT AND DOCUMENTATION

After installing, you can find documentation for this module with the
perldoc command.

    perldoc PkgConfig

You can also look for information at:

    RT, CPAN's request tracker
        http://rt.cpan.org/NoAuth/Bugs.html?Dist=PkgConfig

    AnnoCPAN, Annotated CPAN documentation
        http://annocpan.org/dist/PkgConfig

    CPAN Ratings
        http://cpanratings.perl.org/d/PkgConfig

    Search CPAN
        http://search.cpan.org/dist/PkgConfig/


LICENSE AND COPYRIGHT

Copyright (C) 2012 M. Nunberg

This program is free software; you can redistribute it and/or modify it
under the terms of either: the GNU General Public License as published
by the Free Software Foundation; or the Artistic License.

See http://dev.perl.org/licenses/ for more information.

if (require(testthat, quietly = TRUE) &&
    require(disposables, quietly = TRUE) &&
    Sys.getenv("NOT_CRAN") == "true") {
  library(pkgconfig)
  test_check("pkgconfig")

} else {
  cat("The testthat and disposables packages are required for unit tests")
}

#' Persistent configuration for R packages
#'
#' This package is meant to be used in other packages, and provides
#' configuration options for them.
#'
#' It is currently very minimal, and has two main functions: one
#' for setting configuration options (\code{\link{set_config}}), and one
#' for querying them (\code{\link{get_config}}).
#'
#' @docType package
#' @name pkgconfig-package
NULL

## This is the environment that stores all parameters

config <- new.env()

## ----------------------------------------------------------------------

#' Query a configuration parameter key
#'
#' Query a configuration parameter key, and return the value
#' set in the calling package(s).
#'
#' @details
#' This function is meant to be called from the package whose
#' behavior depends on it. It searches for the given configuration
#' key, and if it exists, it checks which package(s) it was called
#' from and returns the configuration setting for that package.
#'
#' If the key is not set in any calling package, but it is set in
#' the global environment (i.e. at the R prompt), then it returns that
#' setting.
#'
#' If the key is not set anywhere, then it returns \code{NULL}.
#'
#' @param key The name of the parameter to query.
#' @param fallback Fallback if the parameter id not found anywhere.
#' @return The value of the parameter, or the fallback value if not found.
#'
#' @export

get_config <- function(key, fallback = NULL) {
  result <- get_from_session(key)
  if (is.null(result)) fallback else result[[1]]
}

get_from_session <- function(key) {
  value <- config[[key]]
  if (is.null(value)) return(NULL)

  pkgs <- sys.frames()
  pkgs <- lapply(pkgs, parent.env)
  pkgs <- Filter(pkgs, f = isNamespace)
  pkgs <- vapply(pkgs, environmentName, "")
  pkgs <- unique(pkgs)

  for (p in rev(pkgs)) {
    if (p %in% names(value)) return(value[p])
  }

  if ("R_GlobalEnv" %in% names(value)) {
    return(value["R_GlobalEnv"])
  }

  NULL
}

## ----------------------------------------------------------------------

#' Set a configuration parameter
#'
#' Set a configuration parameter, for the package we are calling from.
#' If called from the R prompt and not from a package, then it sets
#' the parameter for global environment.
#'
#' @param ... Parameters to set, they should be all named.
#' @return Nothing.
#'
#' @export
#' @seealso \code{\link{set_config_in}}

set_config <- function(...) {
  set_config_in(..., .in = parent.frame())
}

check_named_args <- function(...) {
  nn <- names(list(...))
  if (is.null(nn) || any(nn == "")) {
    stop("Some parameters are not named")
  }
}

#' Set a configuration parameter for a package
#'
#' This is a more flexible variant of \code{link{set_config}},
#' and it allows creating an custom API in the package that
#' uses \code{pkgconfig} for its configuration.
#'
#' @details
#' This function is identical to \code{\link{set_config}}, but it allows
#' supplying the environment that is used as the package the configuration
#' is set for. This makes it possible to create an API for setting
#' (and getting) configuration parameters.
#'
#' @param ... Parameters to set, they should be all named.
#' @param .in An environment, typically belonging to a package.
#' @return Nothing.
#'
#' @export
#' @seealso \code{\link{set_config}}
#' @importFrom utils packageName

set_config_in <- function(..., .in = parent.frame()) {
  check_named_args(...)
  who <- packageName(env = .in) %||% "R_GlobalEnv"
  set_config_session(who = who, ...)
}

set_config_session <- function(who, ...) {
  l <- list(...)
  for (n in names(l)) {
    key <- config[[n]] %||% list()
    key[[who]] <- l[[n]]
    config[[n]] <- key
  }
}

context("Global env")

test_that("Global env does not bother packages", {

  evalq(set_config(key3 = "value"), .GlobalEnv)
  on.exit(try(evalq(set_config(key3 = NULL), .GlobalEnv)), add = TRUE)

  on.exit(try(disposables::dispose_packages(pkgs)), add = TRUE)

  pkgs <- disposables::make_packages(
    pkgA = {
      setter <- function() { set_config(key3 = "value2") }
      getter <- function() { utility123456::getter() }
    },
    utility123456 = {
      getter <- function() { get_config("key3", "fallback") }
    }
  )

  pkgA::setter()

  expect_equal(get_config("key3"), "value")
  expect_equal(pkgA::getter(), "value2")
})

context("Creating a custom API")

test_that("We can create a custom API", {

  on.exit(try(disposables::dispose_packages(pkgs)))
  pkgs <- disposables::make_packages(

    utility123456 = {
      set_opt <- function(...) {
        pars <- list(...)
        names(pars) <- paste0("utility123456::", names(pars))
        do.call(pkgconfig::set_config_in,
                c(pars, list(.in = parent.frame())))
      }
      
      get_opt <- function(key) {
        real_key <- paste0("utility123456::", key)
        pkgconfig::get_config(real_key)
      }
    },

    pkgA = {
      setter <- function() { utility123456::set_opt(key4 = "value_A") }
      getter <- function() { utility123456::get_opt("key4") }
    },

    pkgB = {
      setter <- function() { utility123456::set_opt(key4 = "value_B") }
      getter <- function() { utility123456::get_opt("key4") }
    }
  )

  pkgA::setter()
  pkgB::setter()

  expect_equal(pkgA::getter(), "value_A")
  expect_equal(pkgB::getter(), "value_B")
  
})

context("Session")

test_that("Session variables", {

  on.exit(try(disposables::dispose_packages(pkgs)))
  pkgs <- disposables::make_packages(
    pkgconfigtest = {
      f <- function() {
        set_config(foo = "bar")
        get_config("foo")
      }
      g <- function() { get_config("foo") }
      h <- function() { get_config("foobar") }
    }
  )

  expect_equal(f(), "bar")
  expect_equal(g(), "bar")
  expect_null(h())

})


test_that("Composite values", {

  on.exit(try(disposables::dispose_packages(pkgs)))
  pkgs <- disposables::make_packages(
    pkgconfigtest = {
      f <- function() {
        set_config(foo = list(1,2,3))
        get_config("foo")
      }
      g <- function() { get_config("foo") }
      h <- function() { get_config("foobar") }
    }
  )

  expect_equal(f(), list(1,2,3))
  expect_equal(g(), list(1,2,3))
  expect_null(h())

})

context("Keys are private")

test_that("Two packages do not interfere", {

  on.exit(try(disposables::dispose_packages(pkgs)))

  pkgs <- disposables::make_packages(

    pkgA = {
      setter <- function() { pkgconfig::set_config(key = "A") }
      getter <- function() { utility123456::getter() }
    },

    pkgB = {
      setter <- function() { pkgconfig::set_config(key = "B") }
      getter <- function() { utility123456::getter() }
    },

    utility123456 = {
      getter <- function() { pkgconfig::get_config("key") }
    }
  )

  pkgA::setter()
  pkgB::setter()

  expect_equal(pkgA::getter(), "A")
  expect_equal(pkgB::getter(), "B")

})

test_that("Cannot get if set by another package", {

  on.exit(try(disposables::dispose_packages(pkgs)))

  pkgs <- disposables::make_packages(
    pkgconfigtest1 = {
      getter <- function() { get_config("foo") }
      getter_parent <- function() { getter() }
    },
    pkgconfigtest2 = {
      setter <- function() { set_config(foo = "bar") }
    }
  )

  pkgconfigtest2::setter()
  expect_null(pkgconfigtest1::getter_parent())
})

test_that("Setting from .onLoad works fine", {

  on.exit(try(disposables::dispose_packages(pkgs)), add = TRUE)

  pkgs <- disposables::make_packages(
    utility123456 = {
      getter <- function() { pkgconfig::get_config("key", "fallback") }
    },

    pkgA = {
      .onLoad <- function(lib, pkg) { pkgconfig::set_config(key = "A") }
      getter <- function() { utility123456::getter() }
    },

    pkgB = {
      .onLoad <- function(lib, pkg) { pkgconfig::set_config(key = "B") }
      getter <- function() { utility123456::getter() }
    },

    pkgC = {
      getter <- function() { utility123456::getter() }
    }
  )

  expect_equal(pkgA::getter(), "A")
  expect_equal(pkgB::getter(), "B")
  expect_equal(pkgC::getter(), "fallback")

})

#!/bin/csh
if ( $?PKG_CONFIG_PATH ) then
    setenv PKG_CONFIG_PATH ${PKG_CONFIG_PATH}:/usr/local/lib/pkgconfig:/opt/kde/lib/pkgconfig
else
    setenv PKG_CONFIG_PATH /usr/local/lib/pkgconfig:/usr/lib/pkgconfig:/opt/kde/lib/pkgconfig
endif

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/pkgconfig-package.R
\docType{package}
\name{pkgconfig-package}
\alias{pkgconfig-package}
\title{Persistent configuration for R packages}
\description{
This package is meant to be used in other packages, and provides
configuration options for them.
}
\details{
It is currently very minimal, and has two main functions: one
for setting configuration options (\code{\link{set_config}}), and one
for querying them (\code{\link{get_config}}).
}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/getset.R
\name{set_config_in}
\alias{set_config_in}
\title{Set a configuration parameter for a package}
\usage{
set_config_in(..., .in = parent.frame())
}
\arguments{
\item{...}{Parameters to set, they should be all named.}

\item{.in}{An environment, typically belonging to a package.}
}
\value{
Nothing.
}
\description{
This is a more flexible variant of \code{link{set_config}},
and it allows creating an custom API in the package that
uses \code{pkgconfig} for its configuration.
}
\details{
This function is identical to \code{\link{set_config}}, but it allows
supplying the environment that is used as the package the configuration
is set for. This makes it possible to create an API for setting
(and getting) configuration parameters.
}
\seealso{
\code{\link{set_config}}
}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/getset.R
\name{set_config}
\alias{set_config}
\title{Set a configuration parameter}
\usage{
set_config(...)
}
\arguments{
\item{...}{Parameters to set, they should be all named.}
}
\value{
Nothing.
}
\description{
Set a configuration parameter, for the package we are calling from.
If called from the R prompt and not from a package, then it sets
the parameter for global environment.
}
\seealso{
\code{\link{set_config_in}}
}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/getset.R
\name{get_config}
\alias{get_config}
\title{Query a configuration parameter key}
\usage{
get_config(key, fallback = NULL)
}
\arguments{
\item{key}{The name of the parameter to query.}

\item{fallback}{Fallback if the parameter id not found anywhere.}
}
\value{
The value of the parameter, or the fallback value if not found.
}
\description{
Query a configuration parameter key, and return the value
set in the calling package(s).
}
\details{
This function is meant to be called from the package whose
behavior depends on it. It searches for the given configuration
key, and if it exists, it checks which package(s) it was called
from and returns the configuration setting for that package.

If the key is not set in any calling package, but it is set in
the global environment (i.e. at the R prompt), then it returns that
setting.

If the key is not set anywhere, then it returns \code{NULL}.
}
